<?php
/**
 * 管理员登录模块
 * @作者 qinggan <admin@phpok.com>
 * @版权 深圳市锟铻科技有限公司
 * @主页 http://www.phpok.com
 * @版本 5.x
 * @授权 http://www.phpok.com/lgpl.html 开源授权协议：GNU Lesser General Public License
 * @时间 2018年09月11日
**/
if(!defined("PHPOK_SET")){exit("<h1>Access Denied</h1>");}
class login_control extends phpok_control
{
	public function __construct()
	{
		parent::control();
	}

	/**
	 * 登录页面
	 */
	public function index_f()
	{
		if($this->session->val('admin_id')){
			$this->success(P_Lang('您已成功登录'),$this->url('index'));
		}
		$vcode = $this->config["is_vcode"] && function_exists("imagecreate") ? true : false;
		$this->assign("vcode",$vcode);
		$this->view('login');
	}

	//验证登录
	public function check_f()
	{
		if($_SESSION['admin_id']){
			$this->json(P_Lang('您已成功登录，无需再次验证'));
		}
		$user = $this->get('user');
		if(!$user){
			$this->json(P_Lang('管理员账号不能为空'));
		}
		$pass = $this->get('pass');
		if(!$pass){
			$this->json(P_Lang('密码不能为空'));
		}
		//验证码检测
		if($this->config['is_vcode'] && function_exists('imagecreate')){
			$code = $this->get("_code");
			if(!$code){
				$this->json(P_Lang('验证码不能为空'));
			}
			$code = md5(strtolower($code));
			if($code != $_SESSION['vcode_admin']){
				$this->json(P_Lang('验证码填写不正确'));
			}
		}
		$rs = $this->model('admin')->get_one_from_name($user);
		if(!$rs){
			$this->json(P_Lang('管理员信息不存在'));
		}
		if(!password_check($pass,$rs["pass"])){
			$this->json(P_Lang('管理员密码输入不正确'));
		}
		if(!$rs["status"]){
			$this->json(P_Lang("管理员账号已被锁定，请联系超管！"));
		}
		//获取管理员的权限
		if(!$rs["if_system"]){
			$popedom_list = $this->model('admin')->get_popedom_list($rs["id"]);
			if(!$popedom_list){
				$this->json(P_Lang('你的管理权限未设置好，请联系超级管理员进行设置'));
			}
			$_SESSION["admin_popedom"] = $popedom_list;
			//非系统管理员，判断都有哪些站点权限
			$site_id = $this->model('popedom')->get_site_id($popedom_list);
			if(!$site_id){
				$this->json(P_Lang('你的管理权限未设置好，请联系超级管理员进行设置'));
			}
			$_SESSION["admin_site_id"] = $site_id;
		}else{
			$_SESSION["admin_site_id"] = $this->site['id'];
		}
		$_SESSION["admin_id"] = $rs["id"];
		$_SESSION["admin_account"] = $rs["account"];
		$_SESSION["admin_rs"] = $rs;
		if($this->config['develop']){
			$this->session->assign('admin_develop',true);
		}
		
		unset($_SESSION['vcode_admin']);
		$this->json(true);
	}
}